var gXBEL=null;
var gSelectedFolder="";
var gAcceptButton=null;
var gDirty=false;
var gBoxNet=null;

function setcheckbox(aID,aDef)
{
  document.getElementById(aID).checked=gXBEL.settings.getBool(aID,aDef);
}

function getcheckbox(aID)
{
  try
  {
	gXBEL.settings.setBool(aID,document.getElementById(aID).checked);
  }
  catch(e)
  {
	alert(aID);
  }
}


function initFolder(uri)
{
  initServices();
  initBMService();
  var exists=true;
  var res=RDF.GetResource(uri);


  if(! BMSVC.isBookmarkedResource(res)){
    res=RDF.GetResource("NC:BookmarksRoot");
    exists=false;
  }
  var nameArc=RDF.GetResource(gNC_NS+"Name");
  var target=BMDS.GetTarget(res,nameArc,true);
  var name="";
  if(target)
    name=target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  var textbox=document.getElementById("folder-textbox");
  textbox.value=name;

  gSelectedFolder=res.Value;
  dirtyHandler(textbox);

  return exists;
}

function flush()
{
  gXBEL.settings.host="http://www.box.net/"
  gXBEL.settings.user=document.getElementById('username').value;
  gXBEL.settings.password=document.getElementById('password').value;
  gXBEL.settings.protocol="http";
  gXBEL.settings.selectedFolder=gSelectedFolder;
  var checkboxs=document.getElementsByTagName("checkbox");
  for(var i=0; i<checkboxs.length;i++)
    getcheckbox(checkboxs[i].id);
}

function refresh()
{
  if(gDirty && confirm(gXBEL.settings.getString("applyconfirm")))
  {
    onApply();
    return;
  }

  document.getElementById('username').value=gXBEL.settings.user;
  document.getElementById('password').value=gXBEL.settings.password;
    
  setcheckbox("autodownload",false);
  setcheckbox("autoupload",false);

  
  setcheckbox("merge",false);
  
  var exists=initFolder(gXBEL.settings.selectedFolder);

  gDirty=false;
  gAcceptButton.setAttribute("disabled","true");

  var textboxs=document.getElementsByTagName("textbox");
  for(var i=0; i<textboxs.length; i++)
    textboxs[i].setAttribute("dirty","false");
  var checkboxs=document.getElementsByTagName("checkbox");
  for(var j=0; j<checkboxs.length; j++)
    checkboxs[j].setAttribute("dirty","false");
  
  if(!exists)
    dirtyHandler(document.getElementById("folder-textbox"));
  
}

/*  Event Handlers  */
function onOK()
{
  flush();
}

function onLoad()
{
	gXBEL=new BookmarksSynchronizerXBEL();
	
	  gAcceptButton=document.getAnonymousElementByAttribute(document.documentElement, "dlgtype", "extra1");
	  refresh();

	  var textboxs=document.getElementsByTagName("textbox");
	  for(var i=0; i<textboxs.length; i++)
	    textboxs[i].addEventListener("input",function(event){dirtyHandler(event.target);},false);
	  var checkboxs=document.getElementsByTagName("checkbox");
	  for(var j=0; j<checkboxs.length; j++)
	    checkboxs[j].addEventListener("command",function(event){dirtyHandler(event.target);},false);
    
}

function onApply()
{
  if(!gDirty) return;
  gDirty=false;
  gAcceptButton.setAttribute("disabled","true");

  flush();

  var textboxs=document.getElementsByTagName("textbox");
  for(var i=0; i<textboxs.length; i++)
    textboxs[i].setAttribute("dirty","false");
  var checkboxs=document.getElementsByTagName("checkbox");
  for(var j=0; j<checkboxs.length; j++)
    checkboxs[j].setAttribute("dirty","false");
  
}

function dirtyHandler(aTarget)
{
  aTarget.setAttribute("dirty","true");
	
  if(!gAcceptButton || gDirty) return;
  gDirty=true;
  gAcceptButton.setAttribute("disabled","false");
}

/* commands */

function selectBMFolder()
{
  window.open("chrome://boxnetsync/content/selectFolder.xul","_blank","chrome,resizable,modal");
}

function upload()
{
  refresh();

  window.open("chrome://boxnetsync/content/upload.xul","_blank","chrome,resizable,titlebar=no");
  
}
function download()
{
  refresh();
  window.open("chrome://boxnetsync/content/download.xul","_blank","chrome,resizable,titlebar=no");
  
}

function goToHelp()
{
    try
    {
        window.open("http://www.box.net/help/131","Help", 
        "menubar=yes,dependent=yes, location=yes,resizable=yes,scrollbars=yes,status=yes, toolbar=yes, status=yes, directories=yes" );
    }
    catch(ex)
    {
        alert(ex);
    }
}

function LaunchWizard()
{
	try
	{
		window.open("chrome://boxnetsync/content/setup.xul", "_blank", "chrome,centerscreen,modal");
	}
	catch(ex)
    {
        alert(ex);
    }
}

function test()
{
	gBoxNet = new BoxNetService();
	//alert("dfdfdf");
    df = gBoxNet._test();
	//alert(df);
}