var helper =
{
	encodeToUtf8 : function (oStr)
	{
		var utfStr = oStr;
		var uConv = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter); 
		uConv.charset = "UTF-8";	 	 
		utfStr = uConv.ConvertFromUnicode (oStr);	 	 
		return utfStr	
	},
	
	getTempFile : function ()
	{
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
		.getService(Components.interfaces.nsIProperties)
		.get("TmpD", Components.interfaces.nsILocalFile);

		file.append("boxnetsync_" + new Date().getTime() + ".xml");

		return file;
	},
	
	logMessage : function (lMessage)
	{
		try
		{
			var file = Components.classes["@mozilla.org/file/directory_service;1"]
						.getService(Components.interfaces.nsIProperties)
						.get("TmpD", Components.interfaces.nsIFile);
						
			file.append("log.txt");
			file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
			
			var fStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
							.createInstance(Components.interfaces.nsIFileOutputStream);
			
			fStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);
			fStream.write(lMessage, lMessage.length);
			fStream.close();
			
		}
		catch(e)
		{
			alert("Error during logging: "+e);
		}
	},
	
	/*setStatus(aStatus)
	{
		cmnData.docForm.getElementById("status").value = aStatus;
	},*/
	
	// Remove leading and trailing whitespace from a string
	trimWhitespace : function(string) {
		var newString  = '';
		var substring  = '';
		var beginningFound = false;
		
		// copy characters over to a new string
		// retain whitespace characters if they are between other characters
		for (var i = 0; i < string.length; i++) {
			
			// copy non-whitespace characters
			if (string.charAt(i) != ' ' && string.charCodeAt(i) != 9 && string.charCodeAt(i) != 32) {
		
				// if the temporary string contains some whitespace characters, copy them first
				if (substring != '') {
					newString += substring;
					substring = '';
				}
				newString += string.charAt(i);
				if (beginningFound == false) beginningFound = true;
			}
			
			// hold whitespace characters in a temporary string if they follow a non-whitespace character
			else if (beginningFound == true) substring += string.charAt(i);
		}
		return newString;
	}
}

var cmnData =
{
    username	: "",
    password	: "",
    file		: "",
    filePath    : "",
    status		: "",
    progress    : 0,
    fileSize    : 0,
    docForm     : "",
    source      : "",
    
    setStatus:function(aStatus, label)
    {
		this.docForm.getElementById(label).value = aStatus;
    }
}