// box.net protocol implementation

function BoxNetService(){
 this.httpObj = new httpObject("http://www.box.net/");
 this.ticket = "";
 this.isError = 0;
}

BoxNetService.prototype=
{
	// TODO: DELETE!
    gAuthKey:null,
    gApiKey:null,
    
	// Holly constants
	restUrl     : "api/1.0/rest",
	xmlUrl	    : "api/1.0/xml",
	downloadUrl : "api/1.0/download/",
	uploadUrl   : "http://upload.box.net/api/1.0/upload/",	
	folderUid   : 0,
	API_KEY     : "jlpayg6sa4bubxjc5vjma6lx3r6z23cv",
    FOLDER_NAME : "Firefox Bookmarks",
    FILE_NAME   : "bookmarks.xml",
    _test:function()
    {	
        try
        {
			this.doLogin("sorantis@gmail.com", "test");
			this.createFolder(0,this.FOLDER_NAME);
			this.uploadFile(cmnData);
			//this.GetFolderId(0);
			//this.downloadFile(cmnData);
		}
		catch(ex)
		{
			alert(ex);
		}
    },
    
    doUpload : function ()
    {
		try
        {
			cmnData.setStatus("Logging in...","status");
			this.doLogin();
			if(this.isError != 1)
			{
				this.createFolder(0,"Firefox Bookmarks");
				this.uploadFile();
			}
			else
			{
				cmnData.status = "Failed";
				cmnData.setStatus(cmnData.status,"status");
			}
		}
		catch(ex)
		{
			alert(ex);
		}
    },
    
    doDownload : function ()
    {
		try
		{
			cmnData.setStatus("Logging in...","status");
			this.doLogin();
			if(this.isError != 1)
			{
				this.GetFolderId(0);
				this.downloadFile();
			}
			else
			{
				cmnData.status = "Failed";
				cmnData.setStatus(cmnData.status,"status");
			}
		}
		catch(ex)
		{
			alert(ex);
		}
    },
    
    getTicket : function (objResponse, isResponse)
    {
    	try
    	{
    		if (isResponse)
    		{
    			var xmlDoc = objResponse.xmlDoc;
    			if (xmlDoc != null)
    			{
    				var resStatus = xmlDoc.getElementsByTagName("status")[0].firstChild.nodeValue;
    				if (resStatus == "get_ticket_ok")
    				{
    					this.ticket = xmlDoc.getElementsByTagName("ticket")[0].firstChild.nodeValue;
    				}
    				else
    				{
    					
    					throw "Failed getting ticket! " + resStatus;
    				}
    			}
    		}
    		else
    		{	
    			var strXml = "<?xml version='1.0' encoding='UTF-8' ?><request><action>get_ticket</action><api_key>" + this.API_KEY + "</api_key></request>";
    			this.httpObj.doRequest("POST", this.xmlUrl, "", strXml, true, null, this, "getTicket");			
    		}
    	}
    	catch (ex)
    	{
    		alert(ex);
		}
    },
    
    getResponseStatus : function (objResponse)
	{
		var xmlDoc = objResponse.xmlDoc;
		if (xmlDoc != null)
		{
			var nodeStatus = xmlDoc.getElementsByTagName("status");	
			
			this.responseStatus = nodeStatus[0].firstChild.nodeValue;
			this.responseStatus = this.responseStatus.toString().replace(/\n/gi, "");
			this.responseStatus = helper.trimWhitespace(this.responseStatus.toString());
			
			if (this.responseStatus == "not_logged_in")
			{	
				this.isError = 1;
				this.errorMesg = "You are not logged in correctly!";
			} 
			else if (this.responseStatus == "application_restricted")
			{	
				this.isError = 1;
				this.errorMesg = "Current application doesn't have access!";
			} 
		}
	},
	
    onResponseComplete : function (responseObject, responseText)
	{
		if (responseObject.hasErrors != null && responseObject.hasErrors)
		{
			alert(responseObject.eMesg);
			this.isError = 1;
			return;
		}
		this.errorMesg = "";
		this.isError = 0;
		
		if (!responseObject.isText)
			this.getResponseStatus(responseObject);
		
		if (this.isError == 1)
		{
			alert(this.errorMesg);
			return;
		}
		if (responseObject.requestType == "login")
		{
			this.getAuthToken();
			if (this.isError == 0)
				this.actStatus = 1;
			else
				this.actStatus = 0;				
		}
		
		
		else if (responseObject.requestType == "getTicket")
			this.getTicket(responseObject, true);
		else if (responseObject.requestType == "getAuthToken")
			this.getAuthToken(responseObject, true);
		else if (responseObject.requestType == "getFolderId")
			this.GetFId(responseObject);
		else if (responseObject.requestType == "createFolder" || responseObject.requestType == "deleteFile")
			this.onCompleteAddFolder(responseObject, responseText);
		else if (responseObject.requestType == "fileUpload")
			this.onCompleteFileUpload(responseObject);
	},
    
    onCompleteAddFolder : function(responseObject, responseText)
	{
		try{
			if (this.responseStatus == "e_no_parent_folder")
			{
				alert("Invalid parent folder id!");
			}
			else if (this.responseStatus == "e_delete_node")
				alert("Unable to delete the file/folder!");
			else if (this.responseStatus == "create_ok")
			{
				// let's just be silent
			}
			//helper.logMessage(responseText);
			var folderId = responseText.getElementsByTagName("folder_id")[0].firstChild.nodeValue
			this.folderUid = folderId;
		}
		catch(e)
		{
			alert("EXCEPTION:" + e);
		}
	},
	
    GetFId : function (objResponse)
	{
		var xmlDoc = objResponse.xmlDoc;
		if (xmlDoc == null)
		{
			return;
		}
		if (this.responseStatus == "e_folder_id")
		{	
			alert("Invalid folder id!");
			return;
		}
		//helper.logMessage(xmlDoc);
		var mainFolder = xmlDoc.getElementsByTagName("folder")[0];
		
		var nodeFolders = mainFolder.getElementsByTagName("folders")[0];
		var nodeFiles = mainFolder.getElementsByTagName("files")[0];
		if (nodeFolders)
			for (var i = 0; i < nodeFolders.childNodes.length; i++)
			{
				var folderName = nodeFolders.childNodes[i].getAttribute("name");
				var fid = nodeFolders.childNodes[i].getAttribute("id");
				if (folderName == this.FOLDER_NAME)
				{
					this.folderUid = fid;
					this.GetFolderId(this.folderUid);
				}
			}
			
		if (nodeFiles)
			for (var i = 0; i < nodeFiles.childNodes.length; i++)
			{
				var fileName = nodeFiles.childNodes[i].getAttribute("file_name");
				var fid = nodeFiles.childNodes[i].getAttribute("id");
				if (fileName == this.FILE_NAME)
				{
					var size = nodeFiles.childNodes[i].getAttribute("size");
					this.folderUid = fid;
					cmnData.fileSize = size;
					//alert(cmnData.fileSize);
				}
			}	
	},
	
	GetFolderId : function (fid)
	{
		var strRest = "action=get_account_tree&api_key=" + this.API_KEY + "&auth_token=" + this.userToken + "&folder_id=" + fid + "&params[]=nozip&params[]=onelevel";//"<xml><action>account_tree</action><folder_id>" + fid + "</folder_id><one_level>" + oneLevel + "</one_level></xml>";
		this.httpObj.doRequest("POST", this.restUrl, strRest, "", true, null, this, "getFolderId");
	},
	
    getAuthToken : function (objResponse, isResponse)
	{
		try
		{
			if (isResponse)
			{
				var xmlDoc = objResponse.xmlDoc;
				if (xmlDoc != null)
				{
					var resStatus = xmlDoc.getElementsByTagName("status")[0].firstChild.nodeValue;
					if (resStatus == "get_auth_token_ok")
					{
						this.userToken = xmlDoc.getElementsByTagName("auth_token")[0].firstChild.nodeValue;
						if (xmlDoc.getElementsByTagName("login")[0].firstChild == null)
							 throw "Failed getting token! Invalid login.";
						this.userLogin = xmlDoc.getElementsByTagName("login")[0].firstChild.nodeValue;
						if (xmlDoc.getElementsByTagName("space_amount")[0].firstChild)						
							this.totalSpace = Math.ceil(parseInt(xmlDoc.getElementsByTagName("space_amount")[0].firstChild.nodeValue) / 1000000);	
						if (xmlDoc.getElementsByTagName("space_used")[0].firstChild)						
							this.usedSpace = Math.ceil(parseInt(xmlDoc.getElementsByTagName("space_used")[0].firstChild.nodeValue) / 1000000);
					}
					else
					{
						this.isError = 1;
						throw "Failed getting token! " + resStatus;
					}
				}
			}
			else
			{			
				var strXml = "<?xml version='1.0' encoding='UTF-8' ?><request><action>get_auth_token</action><api_key>" + this.API_KEY + "</api_key><ticket>" + this.ticket + "</ticket></request>";
				this.httpObj.doRequest("POST", this.xmlUrl, "", strXml, true, null, this, "getAuthToken");	
			}
		}
		catch (ex)
		{
			alert(ex);
		}
	},
	
    doLogin : function()
	{
	    var userEmail = cmnData.username;
	    var userPwd = cmnData.password;
		this.getTicket();
		var strData = "login=" + encodeURIComponent(userEmail) + 
					  "&password=" + encodeURIComponent(userPwd) + 
					  "&dologin=1&__login=1";
		var url = "api/1.0/auth/" + this.ticket;
		
		this.httpObj.doRequestText("POST", url, "", strData, true, [{name:'Content-Type', value:'application/x-www-form-urlencoded'}], this, "login");
	},
	
	createFolder : function (parentId, folderName)
	{
		var strType = "createFolder";
		var strXml = "<?xml version='1.0' encoding='UTF-8' ?>" + 
					"<request><action>create_folder</action><api_key>" + 
					this.API_KEY + "</api_key><auth_token>" + 
					this.userToken + "</auth_token><parent_id>" 
					+ parentId + "</parent_id><name>" + 
					folderName + "</name><share>0</share></request>";
		try
		{
			this.httpObj.doRequest("POST", this.xmlUrl, "", strXml, true, null, this, strType);
		}
		catch (ex)
		{
			alert(ex);
		}
	},
	
	uploadFile : function ()
	{
	    var objAct = this;
		try
		{
			var uploadUrl = this.uploadUrl + this.userToken + "/" + this.folderUid;
			var filePath = cmnData.filePath;//"C:\\bookmarks.xml";
			//var filePath = "C:\\bookmarks.xml";
			var fileName = this.FILE_NAME;
			const BOUNDARY="---------------------------32191240128944"; 
			
			const MULTI	= "@mozilla.org/io/multiplex-input-stream;1";
			const FINPUT	= "@mozilla.org/network/file-input-stream;1";
			const STRINGIS	= "@mozilla.org/io/string-input-stream;1";
			const BUFFERED	= "@mozilla.org/network/buffered-input-stream;1";
				
			const nsIMultiplexInputStream	= Components.interfaces.nsIMultiplexInputStream;
			const nsIFileInputStream		= Components.interfaces.nsIFileInputStream;
			const nsIStringInputStream		= Components.interfaces.nsIStringInputStream;
			const nsIBufferedInputStream	= Components.interfaces.nsIBufferedInputStream;
			
			var buf = null;
			var fin = null;																	
			var fpLocal  = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
			
			fpLocal.initWithPath(filePath);
			
			if (!fpLocal.exists())
			{
				throw fileName + " " + "not exists.";
			}
			
			fin = Components.classes[FINPUT].createInstance(nsIFileInputStream);				
			fin.init(fpLocal, 1, 0, false); 
			
			buf = Components.classes[BUFFERED].createInstance(nsIBufferedInputStream);
			buf.init(fin, 9000000);
			
			var transportService = Components.classes['@mozilla.org/network/stream-transport-service;1'].
							createInstance(Components.interfaces.nsIStreamTransportService);
			var sheader = "--" + BOUNDARY + "\r\nContent-disposition: form-data;name=\"upload_files\"\r\n\r\n" + "Upload File" ;
			
			sheader += "\r\n";
			sheader += "--" + BOUNDARY + "\r\nContent-disposition: form-data;name=\"new_file1\";filename=\"" + fileName +  "\"\r\n";
	        sheader += "Content-Type: application/octet-stream\r\n\r\n";
		    sheader  = helper.encodeToUtf8(sheader);
		    
			var hsis = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
			hsis.setData(sheader,sheader.length);

			var endsis = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
			var bs = new String("\r\n--" + BOUNDARY + "--\r\n");
			endsis.setData(bs, bs.length);
			
			var uploadStream = Components.classes[MULTI].createInstance(nsIMultiplexInputStream);
			uploadStream.appendStream(hsis);
			
			uploadStream.appendStream(buf);
			
			uploadStream.appendStream(endsis);
        	
			var objAct = this;
			var xmlhttp = this.httpObj.getObject();
			
			xmlhttp.open("POST", uploadUrl, true); 
			xmlhttp.setRequestHeader("Content-Type","multipart/form-data; boundary=" + BOUNDARY);
            xmlhttp.setRequestHeader("Content-Length", (uploadStream.available()));
			/*var progTimer = setInterval (function ()
							{
			var tranSize = totalSize - uploadStream.available();
			cmnData.progress = Math.round(tranSize / totalSize * 100);
			var status = cmnData.status + cmnData.progress + "%";
			cmnData.setStatus(status,"status");
							}, 200);    */ 
			xmlhttp.onreadystatechange = function () 
										{
			if (xmlhttp.readyState != 4)
				return false;
			else
			{
				try
				{
					if (xmlhttp.status >= 200 && xmlhttp.status < 300 )
					{
						buf.close();
						hsis.close();
						if (fin != null)
							fin.close();
					                    
						uploadStream.close();
					                    
						var domParser = new DOMParser();
										
						var xmlDoc = domParser.parseFromString(xmlhttp.responseText, "text/xml");
						
						//helper.logMessage(xmlhttp.responseText);
						
						if (xmlDoc != null)
						{
							var nodeStatus = xmlDoc.getElementsByTagName("status");	
								
							objAct.responseStatus = nodeStatus[0].firstChild.nodeValue;
							objAct.responseStatus = objAct.responseStatus.toString().replace(/\n/gi, "");
							objAct.responseStatus = helper.trimWhitespace(objAct.responseStatus.toString());
						}
										
						if (objAct.responseStatus == "upload_ok")
						{	
							cmnData.status = "Complete";
							cmnData.setStatus(cmnData.status,"status");
						}
						
						if (objAct.responseStatus == "upload_some_files_failed")
						{
							cmnData.status =  "Upload failed for some files!";
							cmnData.setStatus(cmnData.status,"status");
						}
						else if (objAct.responseStatus == "not_enough_free_space")
						{
							cmnData.status =  "Not enough free space!";
							cmnData.setStatus(cmnData.status,"status");
						}
						
						else if (objAct.responseStatus == "filesize_limit_exceeded")
						{
							cmnData.status =  "File size limit exceeded!";
							cmnData.setStatus(cmnData.status,"status");
						}
						
						else if (objAct.responseStatus == "access_denied")
						{
							cmnData.status = "Access denied!";
							cmnData.setStatus(cmnData.status,"status");
						}
						
					}
					else
					{
						var xmlDoc1 = domParser.parseFromString(xmlhttp.responseText, "text/xml");
						var errorMessage = xmlDoc.getElementsByTagName("Message")[0].firstChild.nodeValue;
						throw "Problem with connection! " + errorMessage;								
					}
				}
				catch (ex)
				{
					alert(ex);
				}
			}
											}
			cmnData.status = "Uploading...";
			cmnData.setStatus(cmnData.status,"status");
			xmlhttp.send(uploadStream); 
			
        }
		catch (ex)
		{	
			alert(ex);
		}
	},
	
	downloadFile : function ()
	{
		try
		{
			var url = this.httpObj.host + this.downloadUrl + this.userToken + "/" + this.folderUid;
			this.httpObj.downloadFile(cmnData, url, this, "fileDownload");
		}
		catch (ex)
		{
			alert(ex);
		}
	}
};